'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var register = require('./register-8c73faa5.js');
var path$1 = _interopDefault(require('path'));
var fs = _interopDefault(require('fs-extra'));
require('react');
require('slash');
require('lz-string');
require('urlsafe-base64');
var fs$1 = _interopDefault(require('fs'));
require('recursive-readdir');
var helpers = require('./helpers-78e61a26.js');
var MemoryFileSystem = _interopDefault(require('memory-fs'));
var webpack = _interopDefault(require('webpack'));
require('webpack-merge');
require('mini-css-extract-plugin');
require('optimize-css-assets-webpack-plugin');
require('terser-webpack-plugin');
var proxy = _interopDefault(require('http-proxy-middleware'));
var WebpackDevServer = _interopDefault(require('webpack-dev-server'));

var cwd = process.cwd();
var config = register.getSsrConfig();

var ufs = require('unionfs').ufs;

var memfs = new MemoryFileSystem();
ufs.use(fs$1).use(memfs);
var development = /*#__PURE__*/(function () {
  var _ref = register._asyncToGenerator( /*#__PURE__*/register._regeneratorRuntime.mark(function _callee2(app) {
    var compiled, _ref2, _ref3, entry, entryPages, webpackConfig, compiler, devServerPort, devServer, proxyMiddleware;

    return register._regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            fs.removeSync(path$1.join(cwd, config.distDir));
            compiled = false;
            _context2.next = 4;
            return helpers.getEntry(memfs);

          case 4:
            _ref2 = _context2.sent;
            _ref3 = helpers._slicedToArray(_ref2, 2);
            entry = _ref3[0];
            entryPages = _ref3[1];
            webpackConfig = helpers.configureWebpack(entry);
            compiler = webpack(webpackConfig);
            compiler.hooks.afterCompile.tap('finish', function () {
              compiled = true;
            });
            compiler.inputFileSystem = ufs;
            devServerPort = 8888;
            devServer = new WebpackDevServer(compiler, {
              hotOnly: true,
              noInfo: true,
              stats: 'errors-only',
              overlay: true,
              compress: false,
              serveIndex: false,
              after: function after(app, server, compiler) {
                var memfs = compiler.outputFileSystem;

                var _loop = function _loop(i) {
                  var page = entryPages[i];
                  var pageId = register.getPageId(page, '_');
                  app.get("/_react-ssr/".concat(pageId, ".css"), function (req, res) {
                    var filename = path$1.join(cwd, config.distDir, "".concat(pageId, ".css"));
                    var style = memfs.existsSync(filename) ? memfs.readFileSync(filename).toString() : '';
                    res.writeHead(200, {
                      'Content-Type': 'text/css'
                    });
                    res.end(style, 'utf-8');
                  });
                  app.get("/_react-ssr/".concat(pageId, ".js"), function (req, res) {
                    var filename = path$1.join(cwd, config.distDir, "".concat(pageId, ".js"));
                    var script = memfs.readFileSync(filename).toString();
                    res.status(200).type('.js').send(script);
                  });
                };

                for (var i = 0; i < entryPages.length; i++) {
                  _loop(i);
                }
              }
            });

            register._asyncToGenerator( /*#__PURE__*/register._regeneratorRuntime.mark(function _callee() {
              return register._regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      devServer.listen(devServerPort);

                    case 1:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            }))();

          case 15:

            if (!compiled) {
              _context2.next = 18;
              break;
            }

            return _context2.abrupt("break", 22);

          case 18:
            _context2.next = 20;
            return register.sleep(100);

          case 20:
            _context2.next = 15;
            break;

          case 22:
            proxyMiddleware = proxy({
              target: "http://localhost:".concat(devServerPort),
              changeOrigin: true,
              ws: true,
              logLevel: 'debug'
            }); // app.use('*', proxyMiddleware);

            app.use('/sockjs-node*', proxyMiddleware); // app.use('/*.json', proxyMiddleware);

            app.use('/*.css', proxyMiddleware);
            app.use('/*.js', proxyMiddleware);
            app.use('/*.json', proxyMiddleware); // app.use('/*hot-update.js', proxyMiddleware);
            // app.use('/*hot-update.json', proxyMiddleware);
            // for (let i = 0; i < entryPages.length; i++) {
            //   const page = entryPages[i];
            //   const pageId = getPageId(page, '_');
            //   app.use(`/_react-ssr/${pageId}.css`, proxyMiddleware);
            // }
            // for (let i = 0; i < entryPages.length; i++) {
            //   const page = entryPages[i];
            //   const pageId = getPageId(page, '_');
            //   app.use(`/_react-ssr/${pageId}.js`, proxyMiddleware);
            // }

          case 27:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
})();

exports.default = development;
